package AWT;

import java.awt.*;
import java.io.*;
import java.util.*;

final public class ScrollbarLabelPanel extends Panel {
    Label label;
    Scrollbar scrollbar;

    public ScrollbarLabelPanel(String text, int  alignment, int  value, int  minimum, int  maximum,
			       boolean horizontal) {
	label = new Label(text,alignment);
	scrollbar = new Scrollbar(Scrollbar.HORIZONTAL,value,(maximum - minimum)/100 + 1,minimum,maximum);
	if (horizontal)
	    setLayout(new GridLayout(1,0));
	else      
	    setLayout(new GridLayout(0,1));
	add(label);
	add(scrollbar);
	validate();
    }

    final public int getLineIncrement() {
	return scrollbar.getLineIncrement();
    }

    final public int getMaximum() {
	return scrollbar.getMaximum();
    }

    final public int getMinimum() {
	return scrollbar.getMinimum();
    }

    final public int getOrientation() {
	return scrollbar.getOrientation();
    }
 
    final public int getPageIncrement() {
	return scrollbar.getPageIncrement();
    }

    final public int getValue() {
	return scrollbar.getValue();
    }

    final public int getVisible() {
	return scrollbar.getVisible() ;
    }

    final public void setLineIncrement(int l) {
	scrollbar.setLineIncrement(l);
    }

    final public void setPageIncrement(int l) {
	scrollbar.setBlockIncrement(l);
    }

    final public void setValue(int value) {
	scrollbar.setValue(value);
    }

    final public void setValues(int value,int visible,int minimum,int maximum) {
	scrollbar.setValues(value,visible,minimum,maximum);
    }

    final public boolean handleEvent(Event event) {
	if (event.target == scrollbar && ScrollbarTextFieldPanel.ScrollbarEvent(event)) {
	    postEvent(new Event(this,event.id,event.arg));
	}
	return super.handleEvent(event);    
    }
}
