package Debug;

import java.io.*;
import java.awt.*;

final public class Debug extends Object {
    public static TextComponent diagnosisTextComponent;

    int iterator;
    String previousString;
    String presentString;
    String newString;

    public Debug(String string) {
	iterator = 0;
	newString = string;
	previousString = diagnosisTextComponent.getText();
	presentString = previousString + newString;
	diagnosisTextComponent.setText(presentString);
	diagnosisTextComponent.postEvent(
	    new DebugEvent(diagnosisTextComponent,DebugEvent.STARTED_DEBUG_THREAD,newString));
    }

    final public void SetIterator(int in_iterator) {
	iterator = in_iterator;
    }

    final public int GetIterator() {
	return iterator;
    }

    final public void Reset(String string) {
	iterator = 0;
	newString = string;
	presentString = previousString + newString;
	diagnosisTextComponent.setText(presentString);
	diagnosisTextComponent.postEvent(
	    new DebugEvent(diagnosisTextComponent,DebugEvent.RESET_DEBUG_THREAD,newString));
    }

    final public void Terminate() {
	diagnosisTextComponent.setText(previousString);
	diagnosisTextComponent.postEvent(
	    new DebugEvent(diagnosisTextComponent,DebugEvent.FINISHED_DEBUG_THREAD,newString));
    }

    final public void Iterate() {
	diagnosisTextComponent.setText(presentString + " " + ++iterator + " ");	
	diagnosisTextComponent.postEvent(
	    new DebugEvent(diagnosisTextComponent,DebugEvent.ITERATE_DEBUG_THREAD,newString));
    }
}
