package LinearAlgebra;

final public class CovarianceMatrix2D extends Object implements CovarianceMatrix {
    double xx;
    double xy;
    double yy;

    protected CovarianceMatrix2D() {
	xx = 0;
	xy = 0;
	yy = 0;
    }

    final public void AddEqual(Vektor y_i,double weight) {
	double coordX = ((Vektor2D)y_i).coordX;	
	double coordY = ((Vektor2D)y_i).coordY;	
	xx += weight * coordX * coordX;
	xy += weight * coordX * coordY;
	yy += weight * coordY * coordY;	
    }

    final public void SubEqual(Vektor y_i,double weight) {
	double coordX = ((Vektor2D)y_i).coordX;	
	double coordY = ((Vektor2D)y_i).coordY;	
	xx -= weight * coordX * coordX;
	xy -= weight * coordX * coordY;
	yy -= weight * coordY * coordY;	
    }

    //  \sum_i=1^n (y_i^tA)y_i
    final public Vektor Mul(Vektor A) {
	double coordX = ((Vektor2D)A).coordX;	
	double coordY = ((Vektor2D)A).coordY;	
	return new Vektor2D(coordX*xx + coordY*xy,coordX*xy + coordY*yy);
    }

    //  \sum_i=1^n (y_i^tA)^2
    final public double MulSquared(Vektor A) {
	double coordX = ((Vektor2D)A).coordX;	
	double coordY = ((Vektor2D)A).coordY;	
	return coordX*coordX*xx + coordY*coordY*yy + 2*coordX*coordY*xy; 
    }

    // \sum_i=1^n y_i^ty_i
    final public double GetNorm2Squared() {
	return xx + yy;
    }
}




