package PrincipalCurve;

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;

import Bitmap.Template;

final public class  PrincipalCurveAlgorithmThreadForSkeletonization extends PrincipalCurveAlgorithmForSkeletonization 
implements Runnable {
    private Thread algorithmThread = null;
    
    // Actions
    int action;
    public final static int ACTION_INIT = 0;
    public final static int ACTION_SKELETONIZE = 1;
    public final static int ACTION_RESTRUCTURE = 2;
    public final static int ACTION_START = 3;
    public final static int ACTION_FIT_AND_SMOOTH = 4;
    public final static int ACTION_TERMINATE = 5;
    
    public PrincipalCurveAlgorithmThreadForSkeletonization(Template in_template,PrincipalCurveClass initialCurve) {
	super(in_template,initialCurve);
	start();
    }

    final public void start() {
        if (algorithmThread == null) {
            algorithmThread = new Thread(this, "PrincipalCurveAlgorithm");
            algorithmThread.start();
        }
    }

    final public void stop() {
        algorithmThread = null;
    }

    final public void run() {
	boolean cont = true;
	algorithmThread.setPriority(Thread.MIN_PRIORITY);
	Thread myThread = Thread.currentThread();
	while(algorithmThread == myThread && cont) {
	    ActionLoopIsWaiting();
	    stop = false;
	    switch(action) {
	      case ACTION_SKELETONIZE:
		  Skeletonize();
		  break;
	      case ACTION_INIT:
		  Initialize();
		  break;
	      case ACTION_FIT_AND_SMOOTH:
		  OuterStep();
		  break;
	      case ACTION_RESTRUCTURE:
		  Restructure();
		  break;
	      case ACTION_START:
		  Start();
		  break;
	      case ACTION_TERMINATE:
		  cont = false;
		  break;
	    }
	}
    }

    final public synchronized void ActionLoopIsWaiting() {
	try {
	    wait();
	} catch (InterruptedException e) { }
    }
    
    final public synchronized void SetAction(int in_action) {
	action = in_action;
	notifyAll();
    }

    final public synchronized void ReleaseStep() {
	notifyAll();
    }
    
    final public void Stop() {
	stop = true;
    }
}
